package com.wsdf.androidlockcontrol.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.CheckBox;
import android.widget.TextView;

import com.wsdf.androidlockcontrol.R;
import com.wsdf.androidlockcontrol.entity.LockItem;

import java.util.List;

public class LockAdapter extends BaseAdapter {

    private List<LockItem> lockItems;
    private LayoutInflater inflater;
    private boolean[] status;

    public LockAdapter(List<LockItem> lockItems, Context context) {
        this.lockItems = lockItems;
        this.inflater = LayoutInflater.from(context);
        this.status = new boolean[lockItems.size()];
    }

    @Override
    public int getCount() {
        return lockItems.size();
    }

    @Override
    public Object getItem(int position) {
        return lockItems.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder vh;
        if (convertView == null) {
            vh = new ViewHolder();
            convertView = inflater.inflate(R.layout.lv_lock_item, null);
            vh.tvLockItem = convertView.findViewById(R.id.tv_lock_item_name);
            vh.cbLockItem = convertView.findViewById(R.id.cb_lock_item);
            convertView.setTag(vh);
        } else {
            vh = (ViewHolder) convertView.getTag();
        }

        LockItem li = lockItems.get(position);
        vh.tvLockItem.setText(li.getName());
        status[position] = li.isCheck();
        vh.cbLockItem.setChecked(status[position]);

        return convertView;
    }

    static class ViewHolder {
        TextView tvLockItem;
        CheckBox cbLockItem;
    }
}
