package com.wsdf.androidlockcontrol.base;

import android.os.Bundle;

import androidx.appcompat.app.AppCompatActivity;

import com.wsdf.androidlockcontrol.common.ActivityCollector;

import butterknife.ButterKnife;

public abstract class BaseActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getLayoutId() != 0) {
            setContentView(getLayoutId());
            ButterKnife.bind(this);
            ActivityCollector.addActivity(this);
            initView();
            initData();
            addListener();
        }
    }

    protected abstract int getLayoutId();

    protected abstract void initView();

    protected abstract void initData();

    protected abstract void addListener();

    @Override
    protected void onDestroy() {
        super.onDestroy();
        ActivityCollector.removeActivity(this);
    }
}
